Index: src/Fl_Pixmap.cxx
===================================================================
--- src/Fl_Pixmap.cxx	(revision 4017)
+++ src/Fl_Pixmap.cxx	(working copy)
@@ -121,7 +121,9 @@
     src.top = cy; src.bottom = cy+H;
     dst.left = X; dst.right = X+W;
     dst.top = Y; dst.bottom = Y+H;
-    RGBColor rgb;
+    RGBColor rgb, oldfg, oldbg;
+    GetForeColor(&oldfg);
+    GetBackColor(&oldbg);
     rgb.red = 0xffff; rgb.green = 0xffff; rgb.blue = 0xffff;
     RGBBackColor(&rgb);
     rgb.red = 0x0000; rgb.green = 0x0000; rgb.blue = 0x0000;
@@ -130,6 +132,8 @@
 	     GetPortBitMapForCopyBits((GrafPtr)mask), 
 	     GetPortBitMapForCopyBits(GetWindowPort(fl_window)),
              &src, &src, &dst);
+    RGBBackColor(&oldbg);
+    RGBForeColor(&oldfg);
   } else {
     fl_copy_offscreen(X, Y, W, H, (Fl_Offscreen)id, cx, cy);
   }
Index: src/Fl_Double_Window.cxx
===================================================================
--- src/Fl_Double_Window.cxx	(revision 4017)
+++ src/Fl_Double_Window.cxx	(working copy)
@@ -115,12 +115,16 @@
   Rect dst;
   GrafPtr dstPort; GetPort(&dstPort);
   dst.top = y; dst.left = x; dst.bottom = y+h; dst.right = x+w;
-  RGBColor rgb;
+  RGBColor rgb, oldbg, oldfg;
+  GetForeColor(&oldfg);
+  GetBackColor(&oldbg);
   rgb.red = 0xffff; rgb.green = 0xffff; rgb.blue = 0xffff;
   RGBBackColor( &rgb );
   rgb.red = 0x0000; rgb.green = 0x0000; rgb.blue = 0x0000;
   RGBForeColor( &rgb );
   CopyBits(GetPortBitMapForCopyBits(gWorld), GetPortBitMapForCopyBits(dstPort), &src, &dst, srcCopy, 0L);
+  RGBBackColor(&oldbg);
+  RGBForeColor(&oldfg);
 }
 
 void fl_delete_offscreen(GWorldPtr gWorld) {
